## kdiff3 1.11.2

=== debian/changelog ===
kdiff3 (1.11.2-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sat, 29 Jun 2024 14:55:07 +0200

kdiff3 (1.11.1-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Thu, 23 May 2024 13:15:20 +0200

kdiff3 (1.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes required.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.19
    - bump Qt packages to 5.15.5
    - bump KF packages to 5.95.0
    - add libkf5xmlgui-dev
    - drop libkf5parts-dev
  * Modernize building:
    - add the dh-sequence-kf5 build dependency to use the kf5 addon
      automatically, removing pkg-kde-tools
    - drop all the manually specified addons and buildsystem for dh
  * Drop mipsel from the list of architectures that need -latomic, as that
    architecture was dropped.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Wed, 01 May 2024 07:24:15 +0200

=== debian/control ===
Source: kdiff3
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Eike Sauer <eike@debian.org>,
 Pino Toscano <pino@debian.org>,
Section: kde
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-kf5,
 gettext,
 cmake (>= 3.19~),
 extra-cmake-modules (>= 5.95.0~),
 qtbase5-dev (>= 5.15.5~),
 libkf5config-dev (>= 5.95.0~),
 libkf5coreaddons-dev (>= 5.95.0~),
 libkf5crash-dev (>= 5.95.0~),
 libkf5doctools-dev (>= 5.95.0~),
 libkf5i18n-dev (>= 5.95.0~),
 libkf5kio-dev (>= 5.95.0~),
 libkf5widgetsaddons-dev (>= 5.95.0~),
 libkf5xmlgui-dev (>= 5.95.0~),
 libboost-dev (>= 1.71.0~),
 xauth <!nocheck>,
 xvfb <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://kde.org/applications/development/kdiff3
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiff3
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdiff3.git

Package: kdiff3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: kdiff3-doc
Description: compares and merges 2 or 3 files or directories
 KDiff3 compares two or three input files and shows the differences
 line by line and character by character. It provides an automatic
 merge facility and an integrated editor for comfortable solving of
 merge conflicts. KDiff3 allows recursive directory comparison and
 merging as well. KDiff3 also has KIO support, so it can access to
 remote files and compressed archives.

Package: kdiff3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Recommends: kdiff3
Description: documentation for KDiff3
 KDiff3 compares two or three input files and shows the differences
 line by line and character by character.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

archs_that_need_atomic = armel m68k powerpc sh4
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@

override_dh_auto_test:
	xvfb-run -a dh_auto_test

execute_after_dh_auto_install:
	# drop translations of Windows-only component
	rm debian/tmp/usr/share/locale/*/LC_MESSAGES/diff_ext.mo

## kdiff3 1.11.4

=== debian/changelog ===
kdiff3 (1.11.4-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Fri, 13 Sep 2024 06:36:35 +0200

kdiff3 (1.11.3-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Sep 2024 17:12:44 +0200

## kdiff3 1.11.5

=== debian/changelog ===
kdiff3 (1.11.5-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Thu, 14 Nov 2024 22:31:23 +0100

## kdiff3 1.12.0

=== debian/changelog ===
kdiff3 (1.12.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies following the port to Qt 6:
    - remove qtbase5-dev, libkf5config-dev, libkf5coreaddons-dev,
      libkf5crash-dev, libkf5doctools-dev, libkf5i18n-dev, libkf5kio-dev,
      libkf5widgetsaddons-dev, and libkf5xmlgui-dev
    - add qt6-base-dev, qt6-5compat-dev, libkf6config-dev, libkf6coreaddons-dev,
      libkf6crash-dev, libkf6doctools-dev, libkf6i18n-dev, libkf6kio-dev,
      libkf6widgetsaddons-dev, and libkf6xmlgui-dev
  * Update the other build dependencies according to the upstream build system:
    - bump cmake to 3.22
    - bump extra-cmake-modules to 6.2
    - bump libboost-dev to 1.82.0
    - add libicu-dev
  * Switch the kf5 dh addon to kf6.
  * Disable/empty the list of architectures that need -latomic for now,
    to check whether it is still needed with Qt 6.

 -- Pino Toscano <pino@debian.org>  Tue, 04 Feb 2025 18:40:28 +0100

=== debian/control ===
--- 
+++ 
@@ -5,20 +5,22 @@
 Section: kde
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
- dh-sequence-kf5,
+ dh-sequence-kf6,
  gettext,
- cmake (>= 3.19~),
- extra-cmake-modules (>= 5.95.0~),
- qtbase5-dev (>= 5.15.5~),
- libkf5config-dev (>= 5.95.0~),
- libkf5coreaddons-dev (>= 5.95.0~),
- libkf5crash-dev (>= 5.95.0~),
- libkf5doctools-dev (>= 5.95.0~),
- libkf5i18n-dev (>= 5.95.0~),
- libkf5kio-dev (>= 5.95.0~),
- libkf5widgetsaddons-dev (>= 5.95.0~),
- libkf5xmlgui-dev (>= 5.95.0~),
- libboost-dev (>= 1.71.0~),
+ cmake (>= 3.22~),
+ extra-cmake-modules (>= 6.2.0~),
+ qt6-base-dev (>= 6.6.0~),
+ qt6-5compat-dev (>= 6.6.0~),
+ libkf6config-dev (>= 6.2.0~),
+ libkf6coreaddons-dev (>= 6.2.0~),
+ libkf6crash-dev (>= 6.2.0~),
+ libkf6doctools-dev (>= 6.2.0~),
+ libkf6i18n-dev (>= 6.2.0~),
+ libkf6kio-dev (>= 6.2.0~),
+ libkf6widgetsaddons-dev (>= 6.2.0~),
+ libkf6xmlgui-dev (>= 6.2.0~),
+ libboost-dev (>= 1.82.0~),
+ libicu-dev (>= 70.0~),
  xauth <!nocheck>,
  xvfb <!nocheck>,
 Standards-Version: 4.7.0

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-archs_that_need_atomic = armel m68k powerpc sh4
+archs_that_need_atomic = none
 ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
 endif

## kdiff3 1.12.1

=== debian/changelog ===
kdiff3 (1.12.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - drop qt6-5compat-dev, no more needed
  * Drop the atomic handling in debian/rules for good, as it does not seem
    needed anymore.

 -- Pino Toscano <pino@debian.org>  Tue, 18 Feb 2025 22:45:46 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
  cmake (>= 3.22~),
  extra-cmake-modules (>= 6.2.0~),
  qt6-base-dev (>= 6.6.0~),
- qt6-5compat-dev (>= 6.6.0~),
  libkf6config-dev (>= 6.2.0~),
  libkf6coreaddons-dev (>= 6.2.0~),
  libkf6crash-dev (>= 6.2.0~),

## kdiff3 1.12.2

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

#cmake < 3.1 has no sane way of checking C++11 features and needed flags
#CMP0077 is defined in 3.13 or later
cmake_minimum_required(VERSION 3.22...3.30 FATAL_ERROR)

project(kdiff3 VERSION 1.12.2)

if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.2)
    message(WARNING "gcc < 9.2 is not recomended support is best effort-only.")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)
set(CMAKE_CXX_EXTENSIONS ON ) #disable trigraphs in clang/gcc -- officially removed in c++17
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CXX_STANDARD_REQUIRED ON)#Force early fail if we cann't get c++17.

set(KF_MIN_VERSION "6.2.0")

find_package(ECM ${KF_MIN_VERSION} CONFIG REQUIRED)
set(
    CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${ECM_MODULE_PATH}
)

set(QT_MAJOR_VERSION "6")
set(QT_MIN_VERSION "6.6.0")

set(KF_MAJOR_VERSION "6")

# project uses settings default as of KDECompilerSettings in ECM 5.85.0
set(KDE_QT_MODERNCODE_DEFINITIONS_LEVEL 5.85.0)
set(KDE_COMPILERSETTINGS_LEVEL 5.85.0)
# pedantic compilers are not supported at this time.
set(KDE_SKIP_PEDANTIC_WARNINGS_SETTINGS TRUE)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(FeatureSummary)

#Full QT_NO_CAST_FROM_ASCII is not compatiable with kdiff3 code and not worth inforcing
#we use the slightly less strict QT_RESTRICTED_CAST_FROM_ASCII
#Disallowing implict cast from QByteArray doesn't make sense for this project
remove_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)
#Causes multiple build errors related to the use QLatin1String
remove_definitions(-DQT_USE_QSTRINGBUILDER)

include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMOptionalAddSubdirectory)
include(ECMSetupQtPluginMacroNames)

ecm_setup_version(${PROJECT_VERSION} VARIABLE_PREFIX KDIFF3 VERSION_HEADER ${CMAKE_BINARY_DIR}/src/version.h)

# Some older versions on boost contain a bug that prevents compiling gcc offers a built-in workaround
# but that isn't enough to ship as clang has no such workaround. 1.65 is known to be affected.
#
# 1.71 or later is required for safe_numerics to work on MSVC otherwise we get a link-time error.
# Change this to 1.84 when its more widely available
find_package(Boost 1.82 REQUIRED)
#needed on craft and possiablely other custom setups.
include_directories(${Boost_INCLUDE_DIRS})

find_package(ICU 70.0 COMPONENTS uc i18n REQUIRED)

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    REQUIRED
    COMPONENTS
    Core
    Gui
    Widgets
    PrintSupport
)

find_package(
    KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION}
    REQUIRED
    COMPONENTS
    I18n
    CoreAddons
    XmlGui
    WidgetsAddons
    Config
    Crash
    KIO #Not fully ready for to build without KIO
    OPTIONAL_COMPONENTS
    DocTools
)

set_package_properties(KF${KF_MAJOR_VERSION}DocTools PROPERTIES PURPOSE "Allows generating and installing docs.")

string(REPLACE "." ";" VERSION_LIST "${KF${KF_MAJOR_VERSION}_VERSION}")
list(GET VERSION_LIST 0 KF_VERSION_MAJOR)
list(GET VERSION_LIST 1 KF_VERSION_MINOR)
list(GET VERSION_LIST 2 KF_VERSION_PATCH)

option(ENABLE_AUTO "Enable kdiff3's '--auto' flag" ON)
option(ENABLE_CLANG_TIDY "Run clang-tidy if available and cmake version >=3.6" OFF)
option(ENABLE_GDBINDEX OFF)

set(CMAKE_CXX_STANDARD 17)
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if(ENABLE_CLAZY)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Xclang -plugin-arg-clazy -Xclang level0,level1,no-overloaded-signal,auto-unexpected-qstringbuilder,unused-non-trivial-variable,returning-void-expression,isempty-vs-count,container-inside-loop,assert-with-side-effects")
    endif()
    #Adjust clang specific  warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wshadow -fexceptions")
    set(CLANG_WARNING_FLAGS "-Wno-unknown-warning-option -Wno-undef -Wno-trigraphs -Wno-invalid-pp-token -Wno-comment -Wshorten-64-to-32 -Wstring-conversion -Wc++11-narrowing -fstack-protector-all")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${CLANG_WARNING_FLAGS}")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    #Make MSVC obey standard C++ exception handling by destroying all objects going out of scope as a result of the exception.
    #This also separates a Microsoft specific exention SEH which catches non-c++ asynchronous exceptions.
    add_compile_options("/EHsc")
    #Suppress MSVCs min/max macros
    add_definitions(-DNOMINMAX)
    #Suppress Microsoft specific C4996 "deprecatation" warnings. Not helpful for code intended to run on any other platform.
    add_definitions(-D_CRT_NONSTDC_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS_GLOBALS)
    #force compliant use of __cplusplus
    add_compile_options("/Zc:__cplusplus")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-trigraphs -Wduplicated-cond -Wduplicated-branches -Wshadow -fexceptions")
endif()

#new in cmake 3.6+ integrate clang-tidy
if(ENABLE_CLANG_TIDY)
    find_program(CLANG_TIDY_EXE NAMES "clang-tidy" DOC "Path to clang-tidy executable")
    if(NOT CLANG_TIDY_EXE)
        message(STATUS "clang-tidy not found disabling integration.")
    else()
        message(STATUS "Found clang-tidy: ${CLANG_TIDY_EXE}")
        set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE}" "-header-filter=.*")
    endif()
endif()

set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS}")

if(ENABLE_AUTO)
    add_definitions(
        -DENABLE_AUTO
    )
endif()

add_definitions(
    -DBOOST_NO_CXX98_FUNCTION_BASE #since we use the header only portion of boost we can hard code this until the upstream fix gets more widely distributed
    -DQT_DEPRECATED_WARNINGS #Get warnings from QT about deprecated functions.
    -DQT_NO_URL_CAST_FROM_STRING # casting from string to url does not always behave as you might think
    -DQT_RESTRICTED_CAST_FROM_ASCII #casting from char*/QByteArray to QString can produce unexpected results for non-latin characters.
    -DQT_NO_KEYWORDS
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_PROCESS_COMBINED_ARGUMENT_START
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060800#warn if deprecated at 6.8 or before. Qt default setting is not useful for kdiff3.
    -DQT_DISABLE_DEPRECATED_BEFORE=0x060600#disable deprecated api for Qt<6.6.
    #Boost 1.74 and possibly others trigger these warnings in boosts own internal headers making
    #the warning useless.
    -DBOOST_ALLOW_DEPRECATED_HEADERS
    #KF5 5.64+ flags
    #Don't warn for API depreciated after 6.6.0 (below as hex.hex.hex number)
    -DKF_DISABLE_DEPRECATED_BEFORE=0x060200#disable deprecated api for KF 6.2.
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060600
    -DKIOCORE_DEPRECATED_WARNINGS_SINCE=0x060600
    -DKXMLGUI_DEPRECATED_WARNINGS_SINCE=0x060600
    -DKF_VERSION_MAJOR=${KF_VERSION_MAJOR}
    -DKF_VERSION_MINOR=${KF_VERSION_MINOR}
    -DKF_VERSION_PATCH=${KF_VERSION_PATCH}
)

#The CMake boolean value is not properly translated if we assign the variable directly to a C/C++ define. clangd will catch this in sytax hightlighting other language servers may not.
if(KF${KF_MAJOR_VERSION}KIO_FOUND)
    add_definitions(
        -DHAS_KFKIO=1
    )
endif()

add_subdirectory(src)
if(KF${KF_MAJOR_VERSION}DocTools_FOUND)
    ecm_optional_add_subdirectory(doc)
    kdoctools_install(po)
else()
    message(WARNING "DocTools not found. Docs will not be generated.")
endif()

ki18n_install(po)

add_subdirectory(kdiff3fileitemactionplugin)

if(WIN32)
add_subdirectory(diff_ext_for_kdiff3)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== kdiff3fileitemactionplugin/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdiff3fileitemactionplugin\")

find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS KIO
	  WidgetsAddons   # KMessageBox
	)

set(kdiff3_fileitemaction_src kdiff3fileitemaction.cpp ../src/Utils.cpp)

ecm_setup_qtplugin_macro_names(
    JSON_NONE
        "K_PLUGIN_FACTORY"
        "K_PLUGIN_CLASS"
    JSON_ARG2
        "K_PLUGIN_FACTORY_WITH_JSON"
        "K_PLUGIN_CLASS_WITH_JSON"
)

kcoreaddons_add_plugin(kdiff3fileitemaction SOURCES ${kdiff3_fileitemaction_src} INSTALL_NAMESPACE "kf${KF_MAJOR_VERSION}/kfileitemaction")
target_link_libraries(kdiff3fileitemaction ICU::uc KF${KF_MAJOR_VERSION}::I18n KF${KF_MAJOR_VERSION}::WidgetsAddons KF${KF_MAJOR_VERSION}::KIOWidgets)

=== debian/changelog ===
kdiff3 (1.12.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes required.

 -- Pino Toscano <pino@debian.org>  Sun, 23 Mar 2025 07:00:43 +0100

## kdiff3 1.12.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 #CMP0077 is defined in 3.13 or later
 cmake_minimum_required(VERSION 3.22...3.30 FATAL_ERROR)
 
-project(kdiff3 VERSION 1.12.2)
+project(kdiff3 VERSION 1.12.3)
 
 if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.2)
     message(WARNING "gcc < 9.2 is not recomended support is best effort-only.")

=== diff_ext_for_kdiff3/CMakeLists.txt ===
#  SPDX-FileCopyrightText: 2003-2006, Sergey Zorin. All rights reserved.
#  SPDX-FileCopyrightText:  2018-2020 Michael Reeves reeves.87@gmail.com
#  SPDX-License-Identifier: BSD-2-Clause

set(kdiff3ext_SRCS
    class_factory.cpp
    diff_ext.cpp
    server.cpp
)

set(kdiff3ext_RCS
    diff_ext_for_kdiff3.rc
)

add_library(kdiff3ext MODULE ${kdiff3ext_SRCS} ${kdiff3ext_RCS})

target_link_libraries(kdiff3ext KF${KF_MAJOR_VERSION}::I18n uuid ole32)
target_compile_definitions(kdiff3ext PRIVATE -DTRANSLATION_DOMAIN=\"kdiff3\" -DUNICODE=1 -Dkdiff3ext)
# Work around buggy windows sdk headers that prevent certain symbols from being exported the normal way
# even though they are required exports for shell exentions.
#
# This works here because only acutally need four "C" style symbols exported.
# C++ symbols are not properly supported by this mechanism
set_target_properties(kdiff3ext PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)


#If we don't do this the nsi packer won't pickup the shell extention library.
install(TARGETS kdiff3ext DESTINATION  ${KDE_INSTALL_PLUGINDIR} )

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

########### kdiff3 executable ###############

set(kdiff3_SRCS
   main.cpp
   kdiff3_shell.cpp
   StandardMenus.cpp
   kdiff3.cpp
   directorymergewindow.cpp
   merger.cpp
   pdiff.cpp
   difftextwindow.cpp
   diff.cpp
   optiondialog.cpp
   mergeresultwindow.cpp
   fileaccess.cpp
   DefaultFileAccessJobHandler.cpp
   gnudiff_analyze.cpp
   gnudiff_io.cpp
   gnudiff_xmalloc.cpp
   common.cpp
   smalldialogs.cpp
   progress.cpp
   ProgressProxy.cpp
   ProgressProxyExtender.cpp
   PixMapUtils.cpp
   MergeFileInfos.cpp
   Utils.cpp
   selection.cpp
   SourceData.cpp
   Overview.cpp
   Logging.cpp
   FileNameLineEdit.cpp
   MergeEditLine.cpp
   Options.cpp
   CommentParser.cpp
   CvsIgnoreList.cpp
   CompositeIgnoreList.cpp
   DirectoryInfo.cpp
   GitIgnoreList.cpp

   kdiff3.qrc
)

ki18n_wrap_ui(kdiff3_SRCS
    scroller.ui
    opendialog.ui
    progressdialog.ui
    FontChooser.ui
)

ecm_optional_add_subdirectory( autotests )

#cann't use add_subdirectory because it changes the scope.
include(icons/CMakeLists.txt)
add_executable(kdiff3 ${kdiff3_SRCS})


target_link_libraries(kdiff3 ICU::uc Qt::PrintSupport KF${KF_MAJOR_VERSION}::ConfigCore KF${KF_MAJOR_VERSION}::ConfigGui KF${KF_MAJOR_VERSION}::XmlGui KF${KF_MAJOR_VERSION}::KIOWidgets KF${KF_MAJOR_VERSION}::Crash KF${KF_MAJOR_VERSION}::I18n KF${KF_MAJOR_VERSION}::CoreAddons )

# See https://cmake.org/cmake/help/v3.15/prop_tgt/MACOSX_BUNDLE_INFO_PLIST.html
if(APPLE)
  set_property(
    TARGET kdiff3
    PROPERTY MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in
  )

  # These are substituted by CMake into plist.in.
  set(MACOSX_BUNDLE_DISPLAY_NAME "KDiff3")
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.KDiff3")
  set(MACOSX_BUNDLE_BUNDLE_NAME "KDiff3")
  set(MACOSX_BUNDLE_DISPLAY_NAME "KDiff3")
  set(MACOSX_BUNDLE_INFO_STRING "KDiff3 - Diff/Patch Frontend")
  set(MACOSX_BUNDLE_LONG_VERSION_STRING "KDiff3 ${KDIFF3_VERSION}")
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDIFF3_VERSION_MAJOR}.${KDIFF3_VERSION_MINOR}")
  set(MACOSX_BUNDLE_BUNDLE_VERSION "${KDIFF3_VERSION}")
  set(MACOSX_BUNDLE_COPYRIGHT "2003- The KDiff3 Authors")
endif()

if(ENABLE_GDBINDEX AND "${CMAKE_SYSTEM_NAME}" MATCHES "Linux" AND "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    find_program(GDBINDEX "gdb-add-index")
    if(GDBINDEX)
        add_custom_command(TARGET kdiff3 POST_BUILD
            COMMAND "${GDBINDEX}" kdiff3
            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
            COMMENT "Running GDB indexing..."
        )
    endif()
endif()

install(TARGETS kdiff3 ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})


########### install files ###############

install( PROGRAMS org.kde.kdiff3.desktop DESTINATION ${KDE_INSTALL_APPDIR} )
install( FILES org.kde.kdiff3.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )

=== doc/en/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kdiff3)
kdoctools_create_manpage (man-kdiff3.1.docbook 1 INSTALL_DESTINATION ${KDE_INSTALL_MANDIR})

=== src/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2018-2021 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    REQUIRED
    COMPONENTS
    Test
)

add_definitions(-DAUTOTEST)

ecm_add_test(connectiontest.cpp
    TEST_NAME "connectiontest"
    LINK_LIBRARIES Qt::Test
)

ecm_add_test(commentparser.cpp ../CommentParser.cpp
    TEST_NAME "commentparser"
    LINK_LIBRARIES Qt::Test
)

ecm_add_test(CvsIgnoreListTest.cpp ../CvsIgnoreList.cpp ../fileaccess.cpp ../Utils.cpp ../ProgressProxy.cpp ../CompositeIgnoreList.cpp ../Logging.cpp
    TEST_NAME "cvsignorelisttest"
    LINK_LIBRARIES ICU::uc Qt::Test Qt::Gui Qt::Widgets
)

ecm_add_test(FileAccessTest.cpp ../fileaccess.cpp ../Utils.cpp ../ProgressProxy.cpp ../CvsIgnoreList.cpp ../CompositeIgnoreList.cpp ../Logging.cpp
    TEST_NAME "fileaccesstest"
    LINK_LIBRARIES ICU::uc Qt::Test Qt::Gui Qt::Widgets
)

ecm_add_test(combinertest.cpp
    TEST_NAME "combinertest"
    LINK_LIBRARIES Qt::Test
)

ecm_add_test(CompositeIgnoreListTest.cpp ../CompositeIgnoreList.cpp
    TEST_NAME "CompositeIgnoreListTest"
    LINK_LIBRARIES Qt::Test
)

ecm_add_test(GitIgnoreListTest.cpp ../GitIgnoreList.cpp ../fileaccess.cpp ../Utils.cpp ../ProgressProxy.cpp ../Logging.cpp
    TEST_NAME "GitIgnoreListTest"
    LINK_LIBRARIES ICU::uc Qt::Test Qt::Gui Qt::Widgets
)

ecm_add_test(datareadtest.cpp ../fileaccess.cpp ../SourceData.cpp ../CommentParser.cpp ../Utils.cpp ../ProgressProxy.cpp ../Logging.cpp
    TEST_NAME "datareadtest"
    LINK_LIBRARIES ICU::uc Qt::Test Qt::Gui Qt::Widgets KF${KF_MAJOR_VERSION}::ConfigCore
)

ecm_add_test(DiffTest.cpp ../diff.cpp ../Logging.cpp ../Utils.cpp ../ProgressProxy.cpp ../gnudiff_io.cpp ../gnudiff_analyze.cpp ../gnudiff_xmalloc.cpp ../fileaccess.cpp ../SourceData.cpp ../CommentParser.cpp
    TEST_NAME "difftest"
    LINK_LIBRARIES  ICU::uc Qt::Test Qt::Gui Qt::Widgets  KF${KF_MAJOR_VERSION}::ConfigCore
)

ecm_add_test(Diff3LineTest.cpp ../diff.cpp ../gnudiff_io.cpp ../gnudiff_analyze.cpp ../gnudiff_xmalloc.cpp ../Logging.cpp ../Utils.cpp ../ProgressProxy.cpp
    TEST_NAME "diff3linetest"
    LINK_LIBRARIES ICU::uc Qt::Test Qt::Gui Qt::Widgets KF${KF_MAJOR_VERSION}::ConfigCore
)

ecm_add_test(ManualDiffHelpListTest.cpp ../diff.cpp ../gnudiff_io.cpp ../gnudiff_analyze.cpp ../gnudiff_xmalloc.cpp ../Logging.cpp ../Utils.cpp ../ProgressProxy.cpp
    TEST_NAME "manualdiffhelplisttest"
    LINK_LIBRARIES ICU::uc Qt::Test Qt::Gui Qt::Widgets KF${KF_MAJOR_VERSION}::ConfigCore
)

=== debian/changelog ===
kdiff3 (1.12.3-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sun, 10 Aug 2025 08:44:06 +0200

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
  libicu-dev (>= 70.0~),
  xauth <!nocheck>,
  xvfb <!nocheck>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://kde.org/applications/development/kdiff3
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiff3

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_test:
	xvfb-run -a dh_auto_test

execute_after_dh_auto_install:
	# drop translations of Windows-only component
	rm debian/tmp/usr/share/locale/*/LC_MESSAGES/diff_ext.mo

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/stable/kdiff3/kdiff3-([\d\.]+)\.tar\.xz

## kdiff3 1.12.3+p24.04+vstable+git20250930.0322

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20250930.0322-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 30 Sep 2025 03:22:18 +0000

kdiff3 (1.12.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 14 May 2025 01:17:14 +0000

kdiff3 (1.12.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 25 Mar 2025 01:17:10 +0000

kdiff3 (1.12.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 19 Feb 2025 01:17:19 +0000

kdiff3 (1.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 09 Dec 2024 01:17:11 +0000

kdiff3 (1.11.5-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 08 Nov 2024 01:17:20 +0000

kdiff3 (1.11.4-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 12 Sep 2024 01:17:14 +0000

kdiff3 (1.11.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 11 Sep 2024 01:17:10 +0000

kdiff3 (1.11.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 29 Jun 2024 01:17:07 +0000

kdiff3 (1.11.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 29 May 2024 01:17:09 +0000

kdiff3 (1.11.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 25 Apr 2024 01:17:49 +0000

kdiff3 (1.10.7-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 14 Dec 2023 01:17:06 +0000

kdiff3 (1.10.6-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 01 Oct 2023 01:17:07 +0000

kdiff3 (1.10.5-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 11 Jul 2023 01:17:07 +0000

kdiff3 (1.10.4-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 20 May 2023 01:17:06 +0000

kdiff3 (1.10.2-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 04 May 2023 01:17:07 +0000

kdiff3 (1.10.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 08 Apr 2023 01:17:05 +0000

kdiff3 (1.10.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 12 Jan 2023 01:17:09 +0000

## kdiff3 1.12.3+p24.04+vstable+git20251002.0436

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20251002.0436-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 02 Oct 2025 04:37:02 +0000

## kdiff3 1.12.3+p24.04+vstable+git20251015.1440

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20251015.1440-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 14:41:00 +0000

## kdiff3 1.12.3+p24.04+vstable+git20251019.0345

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20251019.0345-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 03:45:13 +0000

=== debian/control ===
Source: kdiff3
Uploaders: Eike Sauer <eike@debian.org>, Pino Toscano <pino@debian.org>
Section: kde
Priority: optional
Build-Depends: cmake (>= 3.8~),
               debhelper-compat (= 13),
               gettext,
               kf6-extra-cmake-modules,
               kf6-kconfig-dev,
               kf6-kcoreaddons-dev,
               kf6-kcrash-dev,
               kf6-kdoctools-dev,
               kf6-ki18n-dev,
               kf6-kio-dev,
               kf6-kparts-dev,
               kf6-kwidgetsaddons-dev,
               libboost-dev (>= 1.66.0~),
               libicu-dev,
               pkg-kde-tools-neon,
               qt6-base-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://kde.org/applications/development/kdiff3
Vcs-Git: https://invent.kde.org/neon/extras/kdiff3.git
Vcs-Browser: https://invent.kde.org/neon/extras/kdiff3
Maintainer: Neon CI <neon@kde.org>

Package: kdiff3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: kdiff3-doc
Description: compares and merges 2 or 3 files or directories
 KDiff3 compares two or three input files and shows the differences
 line by line and character by character. It provides an automatic
 merge facility and an integrated editor for comfortable solving of
 merge conflicts. KDiff3 allows recursive directory comparison and
 merging as well. KDiff3 also has KIO support, so it can access to
 remote files and compressed archives.

Package: kdiff3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Recommends: kdiff3
Description: documentation for KDiff3
 KDiff3 compares two or three input files and shows the differences
 line by line and character by character.
 .
 This package contains the documentation.

## kdiff3 1.12.3+p24.04+vstable+git20251028.1018

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20251028.1018-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 28 Oct 2025 10:18:59 +0000

## kdiff3 1.12.3+p24.04+vstable+git20251208.0052

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20251208.0052-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 08 Dec 2025 00:52:46 +0000

## kdiff3 1.12.3+p24.04+vstable+git20251218.0210

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20251218.0210-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 18 Dec 2025 02:10:35 +0000

## kdiff3 1.12.3+p24.04+vstable+git20260107.0748

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20260107.0748-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 07 Jan 2026 07:48:46 +0000

## kdiff3 1.12.3+p24.04+vstable+git20260119.0106

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 #CMP0077 is defined in 3.13 or later
 cmake_minimum_required(VERSION 3.22...3.30 FATAL_ERROR)
 
-project(kdiff3 VERSION 1.12.3)
+project(kdiff3 VERSION 1.12.4)
 
 if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.2)
     message(WARNING "gcc < 9.2 is not recomended support is best effort-only.")

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vstable+git20260119.0106-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 19 Jan 2026 01:06:20 +0000

## kdiff3 1.12.3+p24.04+vunstable+git20260129.0355

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vunstable+git20260129.0355-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 29 Jan 2026 03:55:41 +0000

## kdiff3 1.12.3+p24.04+vunstable+git20260131.0114

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

# Turn off policy change notices from CMake 3.30 and earlier
cmake_minimum_required(VERSION 3.22...3.30)

project(kdiff3 VERSION 1.12.70)

if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.2)
    message(WARNING "gcc < 9.2 is not recommended support is best effort-only.")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)
set(CMAKE_CXX_EXTENSIONS ON ) #Disable trigraphs in clang/gcc -- officially removed in c++17
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CXX_STANDARD_REQUIRED ON) #Force early fail if we can't get c++17.

set(KF_MIN_VERSION "6.2.0")

find_package(ECM ${KF_MIN_VERSION} CONFIG REQUIRED)
set(
    CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${ECM_MODULE_PATH}
)

set(QT_MAJOR_VERSION "6")
set(QT_MIN_VERSION "6.7.0")

set(KF_MAJOR_VERSION "6")

# project uses settings default as of KDECompilerSettings in ECM 5.85.0
set(KDE_QT_MODERNCODE_DEFINITIONS_LEVEL 5.85.0)
set(KDE_COMPILERSETTINGS_LEVEL 5.85.0)
# pedantic compilers are not supported at this time.
set(KDE_SKIP_PEDANTIC_WARNINGS_SETTINGS TRUE)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(FeatureSummary)

# Full QT_NO_CAST_FROM_ASCII is not compatible with kdiff3 code and not worth enforcing
# we use the slightly less strict QT_RESTRICTED_CAST_FROM_ASCII
# Disallowing implicit cast from QByteArray doesn't make sense for this project
remove_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)
#new in QT 6.10+ apparently our auto tests trigger this warning.
add_definitions(-DQT_NO_USE_NODISCARD_FILE_OPEN)

include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMOptionalAddSubdirectory)
include(ECMSetupQtPluginMacroNames)

ecm_setup_version(${PROJECT_VERSION} VARIABLE_PREFIX KDIFF3 VERSION_HEADER ${CMAKE_BINARY_DIR}/src/version.h)

# Some older versions on boost contain a bug that prevents compiling gcc offers a built-in workaround
# but that isn't enough to ship as clang has no such workaround. 1.65 is known to be affected.
#
# 1.71 or later is required for safe_numerics to work on MSVC otherwise we get a link-time error.
# 1.84+ drops problematic pre-c++11 support and is preferred on linux and required for OS X.
# KDiff3 has hard coded BOOST_NO_CXX98_FUNCTION_BASE to compensate for a known issue.
# While this allows compiling with older boost versions we can not use pre-built binaries from boost only the headers.
find_package(Boost 1.83 REQUIRED)
#needed on craft and possibly other custom setups.
include_directories(${Boost_INCLUDE_DIRS})

find_package(ICU 70.0 COMPONENTS uc i18n REQUIRED)

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    REQUIRED
    COMPONENTS
    Core
    Gui
    Widgets
    PrintSupport
)

find_package(
    KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION}
    REQUIRED
    COMPONENTS
    I18n
    CoreAddons
    XmlGui
    WidgetsAddons
    Config
    Crash
    KIO #Not fully ready for to build without KIO
    OPTIONAL_COMPONENTS
    DocTools
)

set_package_properties(KF${KF_MAJOR_VERSION}DocTools PROPERTIES PURPOSE "Allows generating and installing docs.")

string(REPLACE "." ";" VERSION_LIST "${KF${KF_MAJOR_VERSION}_VERSION}")
list(GET VERSION_LIST 0 KF_VERSION_MAJOR)
list(GET VERSION_LIST 1 KF_VERSION_MINOR)
list(GET VERSION_LIST 2 KF_VERSION_PATCH)

option(ENABLE_AUTO "Enable kdiff3's '--auto' flag" ON)
option(ENABLE_CLANG_TIDY "Run clang-tidy if available and cmake version >=3.6" OFF)
option(ENABLE_GDBINDEX OFF)

set(CMAKE_CXX_STANDARD 17)
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if(ENABLE_CLAZY)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Xclang -plugin-arg-clazy -Xclang level0,level1,no-overloaded-signal,auto-unexpected-qstringbuilder,unused-non-trivial-variable,returning-void-expression,isempty-vs-count,container-inside-loop,assert-with-side-effects")
    endif()
    # Adjust clang specific warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wshadow -fexceptions")
    set(CLANG_WARNING_FLAGS "-Wno-unknown-warning-option -Wundef -Wno-trigraphs  -Wno-comment -Wshorten-64-to-32 -Wstring-conversion -Wc++11-narrowing -fstack-protector-all")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${CLANG_WARNING_FLAGS}")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    # Make MSVC obey standard C++ exception handling by destroying all objects going out of scope as a result of the exception.
    # This also separates a Microsoft specific extension SEH which catches non-c++ asynchronous exceptions.
    add_compile_options("/EHsc")
    # Suppress MSVCs min/max macros
    add_definitions(-DNOMINMAX)
    # Suppress Microsoft specific C4996 "deprecation" warnings. Not helpful for code intended to run on any other platform.
    add_definitions(-D_CRT_NONSTDC_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS_GLOBALS)
    # force compliant use of __cplusplus
    add_compile_options("/Zc:__cplusplus")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-trigraphs -Wduplicated-cond -Wduplicated-branches -Wshadow -fexceptions")
endif()

#new in cmake 3.6+ integrate clang-tidy
if(ENABLE_CLANG_TIDY)
    find_program(CLANG_TIDY_EXE NAMES "clang-tidy" DOC "Path to clang-tidy executable")
    if(NOT CLANG_TIDY_EXE)
        message(STATUS "clang-tidy not found disabling integration.")
    else()
        message(STATUS "Found clang-tidy: ${CLANG_TIDY_EXE}")
        set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE}" "-header-filter=.*")
    endif()
endif()

set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS}")

if(ENABLE_AUTO)
    add_definitions(
        -DENABLE_AUTO
    )
endif()

add_definitions(
    -DBOOST_NO_CXX98_FUNCTION_BASE # since we use the header only portion of boost we can hardcode this. This forces c++17 compliance inside boost-headers.
    -DQT_NO_CONTEXTLESS_CONNECT
    -DQT_DEPRECATED_WARNINGS # Get warnings from QT about deprecated functions.
    -DQT_NO_URL_CAST_FROM_STRING # casting from string to url does not always behave as you might think
    -DQT_RESTRICTED_CAST_FROM_ASCII # casting from char*/QByteArray to QString can produce unexpected results for non-latin characters.
    -DQT_NO_KEYWORDS
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_PROCESS_COMBINED_ARGUMENT_START
    -DQT_EXPLICIT_QFILE_CONSTRUCTION_FROM_PATH # preemptive for forward compatibility with Qt 6.9+
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060800    # warn if deprecated at 6.8 or before. Qt default setting is not useful for kdiff3.
    -DQT_DISABLE_DEPRECATED_BEFORE=0x060700    # disable deprecated api for Qt<6.7.
    # Boost 1.74 and possibly others trigger these warnings in boosts own internal headers making
    # the warning useless.
    -DBOOST_ALLOW_DEPRECATED_HEADERS
    # KF5 5.64+ flags
    # Don't warn for API deprecated after 6.6.0 (below as hex.hex.hex number)
    -DKF_DISABLE_DEPRECATED_BEFORE=0x060200#disable deprecated api for KF 6.2.
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060900
    -DKIOCORE_DEPRECATED_WARNINGS_SINCE=0x060900
    -DKXMLGUI_DEPRECATED_WARNINGS_SINCE=0x060900
    -DKF_VERSION_MAJOR=${KF_VERSION_MAJOR}
    -DKF_VERSION_MINOR=${KF_VERSION_MINOR}
    -DKF_VERSION_PATCH=${KF_VERSION_PATCH}
)

# The CMake boolean value is not properly translated if we assign the variable directly to a C/C++ define.
# clangd will catch this in syntax highlighting other language servers may not.
if(KF${KF_MAJOR_VERSION}KIO_FOUND)
    add_definitions(
        -DHAS_KFKIO=1
    )
endif()

add_subdirectory(src)
if(KF${KF_MAJOR_VERSION}DocTools_FOUND)
    ecm_optional_add_subdirectory(doc)
    kdoctools_install(po)
else()
    message(WARNING "DocTools not found. Docs will not be generated.")
endif()

ki18n_install(po)

add_subdirectory(kdiff3fileitemactionplugin)

if(WIN32)
add_subdirectory(diff_ext_for_kdiff3)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== diff_ext_for_kdiff3/CMakeLists.txt ===
#  SPDX-FileCopyrightText: 2003-2006, Sergey Zorin. All rights reserved.
#  SPDX-FileCopyrightText:  2018-2020 Michael Reeves reeves.87@gmail.com
#  SPDX-License-Identifier: BSD-2-Clause

# This does not work for our shell extension.
remove_definitions(-DQT_USE_QSTRINGBUILDER)

set(kdiff3ext_SRCS
    class_factory.cpp
    diff_ext.cpp
    server.cpp
)

set(kdiff3ext_RCS
    diff_ext_for_kdiff3.rc
)

add_library(kdiff3ext MODULE ${kdiff3ext_SRCS} ${kdiff3ext_RCS})

target_link_libraries(kdiff3ext KF${KF_MAJOR_VERSION}::I18n uuid ole32)
target_compile_definitions(kdiff3ext PRIVATE -DTRANSLATION_DOMAIN=\"kdiff3\" -DUNICODE=1 -Dkdiff3ext)
# Work around buggy windows sdk headers that prevent certain symbols from being exported the normal way
# even though they are required exports for shell extensions.
#
# This works here because we actually only need four "C" style symbols exported.
# C++ symbols are not properly supported by this mechanism
set_target_properties(kdiff3ext PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)


# If we don't do this the nsi packer won't pickup the shell extension library.
install(TARGETS kdiff3ext DESTINATION  ${KDE_INSTALL_PLUGINDIR} )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -54,7 +54,7 @@
 
 ecm_optional_add_subdirectory( autotests )
 
-#cann't use add_subdirectory because it changes the scope.
+# can't use add_subdirectory because it changes the scope.
 include(icons/CMakeLists.txt)
 add_executable(kdiff3 ${kdiff3_SRCS})

=== debian/changelog ===
kdiff3 (1.12.3+p24.04+vunstable+git20260131.0114-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 31 Jan 2026 01:14:16 +0000
